
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Addresses_Address_ICE_
#define _Oz_Addresses_Address_ICE_

#ifndef INCLUDE_OZ_BASE_LOCATION
#define INCLUDE_OZ_BASE_LOCATION
	#include <Base/Location.ice>
#endif

module Oz
{
    module Addresses
    {
        interface AddressAdmin
        {
                nonmutating string 
				getCountry();
                
				nonmutating string 
				getCity();
                
				nonmutating string 
				getPostalCode();
                
				nonmutating string 
				getStreet();
        
                idempotent bool 
				setCountry(
					string country);
                
				idempotent bool 
				setCity(
					string city);
                
				idempotent bool 
				setPostalCode(
					string postalCode);
                
				idempotent bool 
				setStreet(
					string street);
        };
        
        
        class Address 
			extends 
				Oz::Base::Location 
			implements 
				AddressAdmin
        {
                string country;
                string city;
                string postalCode;
                string street;
        };
    };
};
#endif

