
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Addresses_AddresBook_ICE_
#define _Oz_Addresses_AddresBook_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ENTIDAD
#define INCLUDE_OZ_BASE_ENTIDAD
	#include <Base/Entidad.ice>
#endif

module Oz
{
	module Addresses
	{
		interface AddressBookAdmin
		{
				idempotent Oz::Base::Entidad*
				createContact(
					string name,
					string type);
				idempotent Oz::Base::Entidad* 
				addContact(
					Oz::Base::Entidad contact);
					
				idempotent bool 
				delContact(
					Ice::Identity idContact);
					
				nonmutating Oz::Base::Entidad* 
				getContact(
					Ice::Identity entidad);
					
				nonmutating Oz::Base::EntidadIdMap 
				getContacts();
				
				nonmutating string 
				getName();
				
				idempotent bool 
				setName(
					string name);
		};
				
		class AddressBook
			extends 
				Oz::Base::OnRez 
			implements 
				AddressBookAdmin
		{
			string name;
			Oz::Base::EntidadIdMap contacts;
		};
		
		dictionary<string,AddressBook*> AddressBookMap;
	};
};
#endif

