
#ifndef _Oz_Base_CacheMap_ICE_
#define _Oz_Base_CacheMap_ICE_

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_BASE_OBJECTCACHE
#define INCLUDE_OZ_BASE_OBJECTCACHE
	#include <Base/ObjectCache.ice>
#endif

module Oz
{
	module Base
	{
		["java:type:java.util.TreeMap"]
			dictionary<long,OnRez*>ObjectPosMap;

		interface CacheMapAdmin
		{

			idempotent void
			setSize(long size);
		
			idempotent void
			addObject(OnRez* obj);

			idempotent void
			deleteObject(long pos);
		};

		interface CacheMapClient
		{

			nonmutating long
			getSize();

			nonmutating ObjectPosMap
			getObjects();

			nonmutating OnRez* 
			getObject(long pos);
		};
		
		/**
		 * Esta clase implementa un sistema cache basico
		 * para proxys de tipo OnRez
		 */

		class CacheMap
			extends 
				Oz::Base::OnRez
			implements
				CacheMapAdmin,
				CacheMapClient
		{
			long size;
			ObjectPosMap objectsByPos;
			ObjectCacheIdMap objectsById;
		};

		
	};
};
#endif

