
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_Coment_ICE_
#define _Oz_Base_Coment_ICE_

#ifndef INCLUDE_OZ_BASE_DATE
#define INCLUDE_OZ_BASE_DATE
	#include <Base/Date.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice> 
#endif

module Oz
{
	module Base
	{
		/**
		 * Operaciones de escritura para cometarios
		 */
		interface ComentWriter
		{			
			idempotent void 
			writeComent(
				string locale,
				string title,
				string coment);
		};
		
		/**
		 * todo
		 */

		interface ComentReader
		{
			nonmutating string 
			getTitle(string locale);
			
			nonmutating string 
			getContent(string locale);
			
			nonmutating Date 
			getDate();
			
			nonmutating Date 
			getUpdateDate();

			nonmutating long
			getNumber();
		};
		
		/**
		* Un comentario que puede ser aadido a cualquier objeto
		* de negocio
		**/
		class Coment 
			extends OnRez 
			implements 
				ComentWriter,
				ComentReader
		{
			long number;
			Date creationDate;
			Date updateDate;
			Oz::Base::StringMap title;
			Oz::Base::StringMap content;
			bool aproved;
		};
	};
};
#endif

