
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_Entidad_ICE_
#define _Oz_Base_Entidad_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_BASE_LOCATION
#define INCLUDE_OZ_BASE_LOCATION
	#include <Base/Location.ice>
#endif

module Oz
{
	module Base
	{
		["java:type:java.util.ArrayList"]
		sequence <Ice::Identity> Identities;
		
		
		interface EntidadAdmin
		{
			nonmutating string 
			getName();	
		};
		
		/**
		 * Gestionar las formas de localizacion de una entidad
		 */
		interface EntidadLocationAdmin
		{
			idempotent Location* 
			addLocation(
				Location localizacion);
				
			idempotent bool 
			removeLocation(
				Ice::Identity id);
				
			nonmutating LocationMap 
			getLocations();
		};
		
		/*
		 * Representa algo ajeno al sistema que se realciona con el
		 * y puede ser localizado.
		 *
		 */
	
		class Entidad extends OnRez implements EntidadAdmin,EntidadLocationAdmin
		{
			string name;
			LocationMap localizaciones;
		};
		
		sequence<Entidad*> EntidadesRefs;
		dictionary<Ice::Identity,Entidad*> EntidadIdMap;
	};
};
#endif

