
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_EventListener_ICE_
#define _Oz_Base_EventListener_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_EVENT
#define INCLUDE_OZ_BASE_EVENT
	#include <Base/Event.ice>
#endif

module Oz
{
	module Base
	{
		/**
		 * Interfaz que permite conectarse y desconectarse a los 
		 * eventos que emite un objeto.
		 */
		 
		interface EventListener
		{
			idempotent void 
			subscribe(
				Ice::Identity objectId,
				string name);
				
			idempotent void 
			unsubscribe(
				Ice::Identity objectId,
				string name);
			
			idempotent void notify(
				Ice::Identity objectId,
				Event e);
		};
	};
};
#endif

