
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_OnRez_ICE_
#define _Oz_Base_OnRez_ICE_

#ifndef INCLUDE_ICESTORM_ICESTORM
#define INCLUDE_ICESTORM_ICESTORM
	#include <IceStorm/IceStorm.ice>
#endif

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_EVENTLISTENER
#define INCLUDE_OZ_BASE_EVENTLISTENER
	#include <Base/EventListener.ice>
#endif

#ifndef INCLUDE_OZ_BASE_EVENTPUBLISHER
#define INCLUDE_OZ_BASE_EVENTPUBLISHER
	#include <Base/EventPublisher.ice>
#endif

#ifndef INCLUDE_OZ_BASE_XMLADMIN
#define INCLUDE_OZ_BASE_XMLADMIN
	#include <Base/XmlAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACL
#define INCLUDE_OZ_BASE_ACL
	#include <Base/Acl.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACLADMIN
#define INCLUDE_OZ_BASE_ACLADMIN
	#include <Base/AclAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZADMIN
#define INCLUDE_OZ_BASE_ONREZADMIN
	#include <Base/OnRezAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_SEARCHADMIN
#define INCLUDE_OZ_BASE_SEARCHADMIN
	#include <Base/SearchAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_INDEXABLE
#define INCLUDE_OZ_BASE_INDEXABLE
	#include <Base/Indexable.ice>
#endif


module Oz
{
    module Base
    {

	/**
	* Clase que aporta una serie de funcionalidades comunes a los obetos de negocio,
	* gestion de acessos, sistema eventos, sistema comentarios.
	*
	**/

        class OnRez 
		implements XmlAdmin,AclAdmin,OnRezAdmin,EventPublisher,
		EventListener,SearchAdmin,ComentAdmin,Indexable
		{
			/**
			 * Lista de claves de texto asociadas al objeto y utilizadas por la 
			 * interface SearchAdmin.
			 *
			 * @see Oz::Base::SearchAdmin
			**/	
			Keys claves;
			
			/**
			*Proxy que referencia a si mismo
			**/
			OnRez* myPx;
			
			/**
			 * Proxy al servicio en el cual se creo el objeto
			 */
			OnRezService* service;
			

			/**
			 *
			 * Topic que se crea en IceStorm como canal de eventos del objeto
			 * @See Event
			 * @See EventListener
			 * @See EventPublisher
			**/

			IceStorm::Topic* topic;

			/**
			 * Mapa de canales de eventos a los que se esta subscrito
			**/
			TopicsMap topics;
			
			/**
			 * Id unico que identifica un objeto en el sistema
			**/
			Ice::Identity id;
			
			/**
			 * Proxy al objeto Acl (Control de listas de accesos) asignado a este
			 * objeto.
			*/
			Acl* aclPx;

			/**
			*Mapa de comentarios
			**/
			long comentNumber;
			

			ComentIdMap comentsId;
			ComentNumberMap comentsNumber;
			
			/**
			 * Attributo para controlar si un objeto admite comentarios
			 */
			bool allowComents;
		};

		/**
		* Definicion de un diccionario generico de objetos OnRez
		**/
		dictionary<Ice::Identity,OnRez*> ObjectIdMap;
	};
};
#endif
