
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Base_OnRezService_ICE_
#define _Oz_Base_OnRezService_ICE_

#ifndef INCLUDE_FREEZE_EVICTOR
#define INCLUDE_FREEZE_EVICTOR
	#include <Freeze/Evictor.ice>
#endif

#ifndef INCLUDE_ICE_OBJECTADAPTER
#define INCLUDE_ICE_OBJECTADAPTER
	#include <Ice/ObjectAdapter.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACL
#define INCLUDE_OZ_BASE_ACL
	#include <Base/Acl.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACLADMIN
#define INCLUDE_OZ_BASE_ACLADMIN
	#include <Base/AclAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACLSERVER
#define INCLUDE_OZ_BASE_ACLSERVER
	#include <Base/AclServer.ice>
#endif

module Oz
{
	module Base
	{
		interface ServiceAdmin
		{
			idempotent bool 
			start();
			
			idempotent bool 
			stop();
			
			nonmutating string 
			getStatus();
			
			nonmutating bool 
			hasObject(
				Ice::Identity id);
			
			idempotent OnRez* 
			add(
				OnRez obj,
				Ice::Identity id);
			
			idempotent bool 
			remove(
				Ice::Identity id); 
		};
		
		
		/**
		 * Servicio basico de objetos negocio, provee una serie de funcionalidades
		 * comunes a los distintos servicios de objetos del sistema. Incluye gestion
		 * de seguridad (ACLS) y persistencia de objetos.
		 */
		
		class OnRezService extends OnRez implements AclServerAdmin,ServiceAdmin
		{
			AclMap acls;
			string status;
		};
	};
};
#endif

