
#ifndef _Oz_Chat_ChatRoom_ICE_
#define _Oz_Chat_ChatRoom_ICE_

#ifndef INCLUDE_ICESTORM_ICESTORM
#define INCLUDE_ICESTORM_ICESTORM
	#include <IceStorm/IceStorm.ice>
#endif

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
    #include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATUSER
#define INCLUDE_OZ_CHAT_CHATUSER
    #include <Chat/ChatUser.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATROOMPARTICIPE
#define INCLUDE_OZ_CHAT_CHATROOMPARTICIPE
	#include <Chat/ChatRoomParticipe.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATOBSERVER
#define INCLUDE_OZ_CHAT_CHATOBSERVER
	#include <Chat/ChatObserver.ice>
#endif

module Oz
{
	module Chat
	{
		interface ChatRoomAdmin
		{
			idempotent void destroy();
		};
	
		interface ChatRoomClient
		{
			nonmutating Ice::Identity getId();
			nonmutating string getName();
			nonmutating ChatUserMap getUsers();
			idempotent ChatRoomParticipe* enter(ChatUser* user,ChatObserver* observer);
			idempotent void exit(string userName);
		};
		
		class ChatRoom 
			implements ChatRoomClient,ChatRoomAdmin
		{
			Ice::Identity id;
			IceStorm::TopicManager* topicManager;
			IceStorm::Topic* topic;
			string name;
			ChatUserMap users;
			ChatObserverMap observers;
			ChatRoomParticipeMap participes;
		};
		
		dictionary <string,ChatRoom*> ChatRoomMap;
	};
};
#endif

