
#ifndef _Oz_Chat_ChatServer_ICE_
#define _Oz_Chat_ChatServer_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_ICESTORM_ICESTORM
#define INCLUDE_ICESTORM_ICESTORM
	#include <IceStorm/IceStorm.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATUSER
#define INCLUDE_OZ_CHAT_CHATUSER
    #include <Chat/ChatUser.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATSESSION
#define INCLUDE_OZ_CHAT_CHATSESSION
    #include <Chat/ChatSession.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATROOM
#define INCLUDE_OZ_CHAT_CHATROOM
    #include <Chat/ChatRoom.ice>
#endif

module Oz
{
	module Chat
	{
		interface ChatServerClient
		{
			nonmutating ChatRoomMap getRooms();
			nonmutating ChatRoom* getRoom(string name);
			idempotent ChatRoom* createRoom(string name);
			idempotent void destroyRoom(string name);
			idempotent bool login(string name,string passwd);
			idempotent ChatSession* createSession(string name);
			idempotent void logout(string name);
		};
		
		class ChatServer implements ChatServerClient
		{
			Ice::Identity id;
			IceStorm::TopicManager* topicManager;
			ChatUserMap users;
			ChatRoomMap rooms;
		};
	};
};
#endif

