
#ifndef _Oz_Chat_ChatSession_ICE_
#define _Oz_Chat_ChatSession_ICE_

#ifndef INCLUDE_OZ_CHAT_CHATUSER
#define INCLUDE_OZ_CHAT_CHATUSER
    #include <Chat/ChatUser.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATROOM
#define INCLUDE_OZ_CHAT_CHATROOM
    #include <Chat/ChatRoom.ice>
#endif

#ifndef INCLUDE_OZ_CHAT_CHATROOMPARTICIPE
#define INCLUDE_OZ_CHAT_CHATROOMPARTICIPE
	#include <ChatRoomParticipe.ice>
#endif

#ifndef INCLUDE_GLACIER2_SESSION
#define INCLUDE_GLACIER2_SESSION
	#include <Glacier2/Session.ice>
#endif
module Oz
{
	module Chat
	{
		class ChatServer;
		class ChatObserver;

		interface ChatSessionClient
		{
			nonmutating Ice::Identity getId();

			nonmutating ChatUser* getUser();
			
			nonmutating bool isActive();
			
			idempotent void active(bool value);
			
			idempotent void logout();
			
			idempotent ChatRoomParticipe*
			enterRoom(string name,ChatObserver* observer);
			
			idempotent void 
			exitRoom(string name);
		};
		
		class ChatSession implements ChatSessionClient,Glacier2::Session
		{
			Ice::Identity id;
			bool actived;
			ChatServer* server;
			ChatUser* user;
			ChatRoomMap rooms;
		};
	};
};
#endif