

#ifndef _Oz_Cms_CmsServer_ICE_
#define _Oz_Cms_CmsServer_ICE_

#ifndef INCLUDE_OZ_BASE_ACLADMIN
#define INCLUDE_OZ_BASE_ACLADMIN
	#include <Base/AclAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZSERVICE
#define INCLUDE_OZ_BASE_ONREZSERVICE
	#include <Base/OnRezService.ice>
#endif

#ifndef INCLUDE_OZ_CMS_CMSSITE
#define INCLUDE_OZ_CMS_CMSSITE
	#include <Cms/CmsSite.ice>
#endif

#ifndef INCLUDE_OZ_DOMAINS_DOMAIN
#define INCLUDE_OZ_DOMAINS_DOMAIN
	#include <Domains/Domain.ice>
#endif

#ifndef INCLUDE_OZ_DOMAINS_GROUP
#define INCLUDE_OZ_DOMAINS_GROUP
	#include <Domains/Group.ice>
#endif

#ifndef INCLUDE_OZ_CMS_USERPROFILE
#define INCLUDE_OZ_CMS_USERPROFILE
	#include <Cms/UserProfile.ice>
#endif

#ifndef INCLUDE_OZ_CMS_CONFIRMATIONMAIL
#define INCLUDE_OZ_CMS_CONFIRMATIONMAIL
	#include <Cms/ConfirmationMail.ice>
#endif

#ifndef INCLUDE_OZ_MAIL_MAILACOUNT
#define INCLUDE_OZ_MAIL_MAILACOUNT
	#include <Mail/MailAcount.ice>
#endif

#ifndef INCLUDE_OZ_CMS_LOCALE
#define INCLUDE_OZ_CMS_LOCALE
	#include <Cms/Locale.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILESYSTEM
#define INCLUDE_OZ_FILES_FILESYSTEM
	#include <Files/FileSystem.ice>
#endif

module Oz
{
	module Cms
	{
		interface CmsServerAdmin
		{
			idempotent CmsSite* createSite(
				string name);
				
			idempotent CmsSite* createSiteRoot();
				
			idempotent void deleteSite(
				string name);
		};

		interface CmsServerClient
		{
			nonmutating CmsSite* getSiteRoot();
			nonmutating CmsSite* getSite(string name);
			nonmutating CmsSiteMap getSites();
		};

		/**
		 * Servicio que gestiona el modelo de los Cms
		 *
		 */

		class CmsServer
			extends Oz::Base::OnRezService
			implements CmsServerAdmin,CmsServerClient
		{
			CmsSite* siteRoot;
			CmsSiteMap sites;
		};
	};
};
#endif

