

#ifndef _Oz_Cms_ConfirmationMail_ICE_
#define _Oz_Cms_ConfirmationMail_ICE_

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACLADMIN
#define INCLUDE_OZ_BASE_ACLADMIN
	#include <Base/AclAdmin.ice>
#endif

#ifndef INCLUDE_OZ_MAIL_MAILACOUNT
#define INCLUDE_OZ_MAIL_MAILACOUNT
	#include <Mail/MailAcount.ice>
#endif

module Oz
{
	module Cms
	{
		interface ConfirmationMailAdmin
		{
			idempotent void
			setSubject(
				string locale,
				string subject);

			nonmutating string
			getSubject(
				string locale);

			idempotent void
			write(
				string locale,
				string message);

			nonmutating string
			read(
				string locale);

			idempotent void
			setMailAcount(
				Oz::Mail::MailAcount* mailAcount);

			nonmutating Oz::Mail::MailAcount*
			getMailAcount();

			idempotent void
			setConfirmationURL(
				string confirmationURL);

			nonmutating string
			getConfirmationURL();

			idempotent void
			setConfirmationIdParameter(
				string confirmationIdParameter);

			nonmutating string
			getConfirmationIdParameter();

			idempotent void
			sendConfirmationMail(
				string mailAddress,
				Ice::Identity confirmationId);
		};

		class ConfirmationMail
			extends
				Oz::Base::OnRez
			implements
				ConfirmationMailAdmin
		{
			Oz::Mail::MailAcount* mailAcount;
			Oz::Base::StringMap subject;
			Oz::Base::StringMap message;
			string confirmationURL;
			string confirmationIdParameter;
		};
	};
};

#endif