
#ifndef _Oz_Cms_Locale_ICE_
#define _Oz_Cms_Locale_ICE_

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILE
#define INCLUDE_OZ_FILES_FILE
	#include <Files/File.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ACLADMIN
#define INCLUDE_OZ_BASE_ACLADMIN
	#include <Base/AclAdmin.ice>
#endif


module Oz
{
	module Cms
	{
		interface LocaleAdmin
		{
			idempotent void 
			setImageFlag(
				Oz::Files::File* imageFlag);
			
			nonmutating Oz::Files::File*
			getImageFlag();

			idempotent void
			setCountryName(
				string languageCode,
				string countryName);

			nonmutating string
			getCountryName(
				string languageCode);

			idempotent void
			setLanguageCode(
				string languageCode);

			nonmutating string
			getLanguageCode();

			idempotent void
			setCountryCode(
				string countryCode);

			nonmutating string
			getCountryCode();
		};

		class Locale 
			extends Oz::Base::OnRez
			implements LocaleAdmin
		{
			Oz::Files::File* imageFlag;
			Oz::Base::StringMap countryName;
			string languageCode; //two letter code according ISO-639
			string countryCode;  //two letter code according ISO-3166
		};
		
		dictionary<string,Locale*> StringLocaleMap;
	};
};

#endif