
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Domains_DomainServer_ICE_
#define _Oz_Domains_DomainServer_ICE_

//Oz includes

#ifndef INCLUDE_OZ_BASE_ONREZSERVICE
#define INCLUDE_OZ_BASE_ONREZSERVICE
	#include <Base/OnRezService.ice>
#endif

#ifndef INCLUDE_OZ_DOMAINS_DOMAIN
#define INCLUDE_OZ_DOMAINS_DOMAIN
	#include <Domains/Domain.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILESERVER
#define INCLUDE_OZ_FILES_FILESERVER
	#include <Files/FileServer.ice>
#endif

module Oz
{
	module Domains
	{
		interface DomainServerAdmin
		{
			idempotent Domain* 
			createDomain(
				string name);
			
			nonmutating Domain* 
			getDomain(
				string name);
			
			nonmutating DomainNameMap 
			getDomains();
			
			idempotent bool 
			delDomain(
				string name);
			
			idempotent bool 
			setFileServer(
				Oz::Files::FileServer* fileServer);
		};
		
		class DomainServer 
			extends 
				Oz::Base::OnRezService 
			implements 
				DomainServerAdmin
		{
			DomainNameMap domains;
			Oz::Files::FileServer* fileServerPx;
		};
	};
};
#endif

