
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Domains_User_ICE_
#define _Oz_Domains_User_ICE_

//Ice includes

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

//Oz includes

#ifndef INCLUDE_OZ_BASE_ENTIDAD
#define INCLUDE_OZ_BASE_ENTIDAD
	#include <Base/Entidad.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILE
#define INCLUDE_OZ_FILES_FILE
	#include <Files/File.ice>
#endif

module Oz
{
	module Domains
	{
		class Domain;
		
		interface SystemLogin
		{
			nonmutating bool 
			login(
				string passwd);
		};
		
		
		interface UserAdmin
		{
			idempotent bool 
			addGroup(
				Ice::Identity group);
			
			idempotent bool 
			delGroup(
				Ice::Identity group);
			
			nonmutating Oz::Base::Identities 
			getGroups();
			
			idempotent bool 
			setPasswd(
				string passwd);
			
			idempotent bool 
			setMail(
				string mail);
			
			nonmutating string 
			getPasswd();
			
			nonmutating string 
			getMail();
			
			nonmutating bool 
			isActived();
			
			nonmutating Oz::Domains::Domain*
			getDomain();
			
			idempotent bool 
			setDomain(
				Oz::Domains::Domain* dominio);
			
			idempotent bool 
			setActived(
				bool actived);
			
			idempotent bool 
			setIcon(
				Oz::Files::File* iconPx);

			nonmutating Oz::Files::File* 
			getIcon();
		};

		class User 
			extends 
				Oz::Base::Entidad  
			implements 
				UserAdmin,
				SystemLogin
		{
			Oz::Files::File* iconPx;
			Domain* dominio;
			string passwd;
			string mail;
			Oz::Base::Identities groups;
			bool actived;
		};

		dictionary<Ice::Identity,User*> UsersMap;
	};
};
#endif

