
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Files_Directory_ICE_
#define _Oz_Files_Directory_ICE_

//Oz includes

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_FILES_NODE
#define INCLUDE_OZ_FILES_NODE
	#include <Files/Node.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILE
#define INCLUDE_OZ_FILES_FILE
	#include <Files/File.ice>
#endif

module Oz
{
	module Files
	{
		class Directory;

		interface DirectoryReader
		{
			nonmutating bool 
			hasNode(
				string name);
			
			nonmutating Node* 
			getNode(
				string path);
			
			nonmutating StringNodeMap 
			list();

			nonmutating IntNodeMap
			listByPos();

			nonmutating int
			countChilds();

			idempotent void
			swapNodes(int pos1,int pos2);
		};

		interface DirectoryWriter
		{
			idempotent bool 
			addChild(
				Node* nodo);

			idempotent void
			deleteChilds();

			idempotent void
			deleteChild(string name);
		};

		class Directory 
			extends 
				Node 
			implements 
				DirectoryReader,
				DirectoryWriter
		{
			StringNodeMap nodes;
			IntNodeMap nodesByPos;
		};
	};
};
#endif

