
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Files_FileServer_ICE_
#define _Oz_Files_FileServer_ICE_

//Oz includes

#ifndef INCLUDE_OZ_BASE_ONREZSERVICE
#define INCLUDE_OZ_BASE_ONREZSERVICE
	#include <Base/OnRezService.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILESYSTEM
#define INCLUDE_OZ_FILES_FILESYSTEM
	#include <Files/FileSystem.ice>
#endif

module Oz
{
	module Files
	{
		dictionary <string,FileSystem*> FileSystemMap;
		
		interface FileServerAdmin
		{
			nonmutating FileSystem* 
			getFileSystem(
				string fileSystem);
			
			nonmutating bool 
			hasFileSystem(
				string fileSystem);
			
			nonmutating FileSystemMap 
			getFileSystems();
			
			idempotent FileSystem* 
			createFileSystem(
				string fileSystem);
		};
		
		
		class FileServer 
			extends 
				Oz::Base::OnRezService 
			implements 
				FileServerAdmin
		{
				FileSystemMap filesMap;
		};
	};
};
#endif

