
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Files_Node_ICE_
#define _Oz_Files_Node_ICE_


//Oz icnludes

#ifndef INCLUDE_OZ_BASE_ACLADMIN
#define INCLUDE_OZ_BASE_ACLADMIN
	#include <Base/AclAdmin.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_BASE_DATE
#define INCLUDE_OZ_BASE_DATE
	#include <Base/Date.ice>
#endif

module Oz
{
	module Files
	{
		class Node;
		class FileSystem;
		
		interface NodeReader
		{
			nonmutating string 
			getName();

			nonmutating string
			getTranslatedName(string locale);
			
			nonmutating string 
			getDescription(string locale);
			
			nonmutating Node* 
			getParent();
			
			nonmutating string 
			getPath();
			
			nonmutating string 
			getContentType();
			
			nonmutating string 
			getExtension();

			nonmutating Oz::Base::Date
			getCreationDate();

			nonmutating Oz::Base::Date
			getUpdateDate();
		};
		
		interface NodeWriter
		{
			idempotent bool 
			setName(
				string name);
			
			idempotent bool
			translateName(string locale,string name);

			idempotent bool 
			setDescription(
				string locale,
				string description);
			
			idempotent bool 
			setParent(
				Node* parent);
			
			idempotent bool 
			setContentType(
				string contentType);
			
			idempotent bool 
			setExtension(
				string extension);

			nonmutating bool
			isHidden();

			idempotent void
			setHidden(bool hidden);

			nonmutating int
			getPos();

			idempotent void
			setPos(int pos);

			idempotent void
			setFileSystem(
				FileSystem* fileSys);

			nonmutating FileSystem*
			getFileSystem();
		};
		
		
		/**
		 * Representa un elemento en el servicio de ficheros
		 */

		class Node 
			extends 
				Oz::Base::OnRez 
			implements 
				NodeReader,
				NodeWriter
		{
			int pos;
			bool hidden;
			Oz::Base::Date creationDate;
			Oz::Base::Date updateDate;
			int lectures;
			FileSystem* fileSys;
			Node* parent;
			string name;
			Oz::Base::StringMap translatedNames;
			Oz::Base::StringMap description;
			string contentType;
			string extension;
		};
		
		["java:type:java.util.TreeMap"]
			dictionary<string,Node*> StringNodeMap;
		["java:type:java.util.TreeMap"]
			dictionary<int,Node*> IntNodeMap;
	};
};
#endif

