
#ifndef _Oz_Mail_Email_ICE_
#define _Oz_Mail_Email_ICE_

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_ADDRESSES_MAILADDRESS
#define INCLUDE_OZ_ADDRESSES_MAILADDRESS
	#include <Addresses/MailAddress.ice>
#endif

module Oz
{
	module Mail
	{
		class MailAcount;

		interface EmailAdmin
		{
			idempotent void 
			setTo(
				Oz::Addresses::MailAddress to);

			idempotent void 
			setCC(Oz::Addresses::MailAddresses cc);
			
			idempotent void 
			setFrom(Oz::Addresses::MailAddress from);
		
			idempotent void 
			setSubject(string subject);
		
			idempotent void 
			setMessage(string message);
	
			nonmutating Oz::Addresses::MailAddress 
			getTo();
			nonmutating Oz::Addresses::MailAddresses 
			getCC();
		
			nonmutating Oz::Addresses::MailAddress 
			getFrom();
		
			nonmutating string 
			getSubject();
		
			nonmutating string 
			getMessage();
	
			idempotent void
			send();

			nonmutating Oz::Mail::MailAcount*
			getMailAcount();
		};
		
		class Email 
			extends 
				Oz::Base::OnRez 
			implements 
				EmailAdmin
		{
			Oz::Mail::MailAcount* mailAcount;
			Oz::Addresses::MailAddress to;
			Oz::Addresses::MailAddress from;
			Oz::Addresses::MailAddresses cc;
			string subject;
			string message;
		};
		
		dictionary <Ice::Identity,Email*> EmailMap;
	};
};
#endif
