#ifndef _MailAcount_H_
#define _MailAcount_H_

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_DOMAINS_USER
#define INCLUDE_OZ_DOMAINS_USER
	#include <Domains/User.ice>
#endif

#ifndef INCLUDE_OZ_MAIL_EMAIL
#define INCLUDE_OZ_MAIL_EMAIL
	#include <Mail/Email.ice>
#endif

#ifndef INCLUDE_OZ_ADDRESSES_MAILADDRESS
#define INCLUDE_OZ_ADDRESSES_MAILADDRESS
	#include <Addresses/MailAddress.ice>
#endif

module Oz
{
	module Mail
	{
		enum MailStorageProtocol{IMAP,POP3};
		
		interface MailAcountAdmin
		{
			idempotent void setUser(Oz::Domains::User* user);
			idempotent void setMailAddress(string mailAddress);
			idempotent void setMailPassword(string password);
			idempotent void setSenderServer(string senderServer);
			idempotent void setReceiverServer(string receiverServer);
			idempotent void setMailStorageProtocol(MailStorageProtocol protocol);

			nonmutating Oz::Domains::User* getUser();
			nonmutating string getMailAddress();
			nonmutating string getMailPassword();
			nonmutating string getSenderServer();
			nonmutating string getReceiverServer();
			nonmutating MailStorageProtocol getMailStorageProtocol();	

			nonmutating EmailMap getInbox();
			nonmutating EmailMap getSentMail();
			nonmutating EmailMap getDrafts();
			nonmutating EmailMap getTrash();
			nonmutating EmailMap getAllMail();

			idempotent Email* createEmail();
		};
		
		class MailAcount 
			extends 
				Oz::Base::OnRez 
			implements 
				MailAcountAdmin
		{
			Oz::Domains::User* user;
			Oz::Addresses::MailAddress mailAddress;
			string mailPassword;
			string senderServer;
			string receiverServer;
			MailStorageProtocol storageProtocol;
			
			EmailMap inbox;
			EmailMap sentMail;
			EmailMap drafts;
			EmailMap trash;
			EmailMap allMail;
		};
		
		dictionary<Ice::Identity,MailAcount*>MailAcountMap;
	};
};
#endif

