
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Prices_PriceList_ICE_
#define _Oz_Prices_PriceList_ICE_

//Oz includes

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_PRICES_PRODUCTPRICE
#define INCLUDE_OZ_PRICES_PRODUCTPRICE
	#include <Prices/ProductPrice.ice>
#endif

#ifndef INCLUDE_OZ_PRODUCTS_PRODUCT
#define INCLUDE_OZ_PRODUCTS_PRODUCT
	#include <Products/Product.ice>
#endif

module Oz
{
	module Prices
	{
		interface PriceListAdmin
		{
			nonmutating string 
			getName();
			
			idempotent bool 
			setName(string name);

			nonmutating ProductPriceMap 
			getPrices();
			
			nonmutating ProductPrice* 
			getPrice(
				Ice::Identity productId);
			
			idempotent bool 
			setPrice(
				Oz::Products::Product* productPx,
				double price);
		};
		
		class PriceList 
			extends 
				Oz::Base::OnRez 
			implements 
				PriceListAdmin
		{
			//This a unique name for each price list
			string name;
			ProductPriceMap prices;
		};

		["java:type:java.util.TreeMap"]
			dictionary<string,PriceList*> PriceListMap;
	};
};
#endif

