
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Prices_PriveVServer_ICE_
#define _Oz_Prices_PriceVServer_ICE_

#ifndef INCLUDE_OZ_BASE_ONREZSERVICE
#define INCLUDE_OZ_BASE_ONREZSERVICE
	#include <Base/OnRezService.ice>
#endif

#ifndef INCLUDE_OZ_PRICES_PRICELIST
#define INCLUDE_OZ_PRICES_PRICELIST
	#include <Prices/PriceList.ice>
#endif

module Oz
{
	module Prices
	{
		interface PriceServerAdmin
		{
			idempotent PriceList* 
			createPriceList(
				string name);
			
			idempotent bool 
			removePriceList(
				string name);
		};
		
		interface PriceServerClient
		{
			nonmutating PriceList* 
			getPriceList(
				string name);
			
			nonmutating PriceListMap 
			getPriceLists();
		};
		
		class PriceServer 
			extends 
				Oz::Base::OnRezService
			implements 
				PriceServerAdmin,
				PriceServerClient
		{
			string name;
			PriceListMap priceLists;
		};
	};
};
#endif

