
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Products_ProductPrice_ICE_
#define _Oz_Products_ProductPrice_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_PRODUCTS_PRODUCTNODE
#define INCLUDE_OZ_PRODUCTS_PRODUCTNODE
	#include <Products/ProductNode.ice>
#endif

module Oz
{
	module Prices
	{
		interface ProductPriceAdmin
		{
			nonmutating Oz::Products::ProductNode* 
			getProduct();
			
			nonmutating double 
			value();

			idempotent void 
			setPrice(
				double precio);
			
			idempotent void 
			setProduct(
				Oz::Products::ProductNode* producto);
		};

		class ProductPrice 
			extends 
				Oz::Base::OnRez 
			implements 
				ProductPriceAdmin
		{
			//The product node must be a product or a productSet
			Oz::Products::ProductNode* producto;
			double price;
		};

		dictionary<Ice::Identity,ProductPrice*> ProductPriceMap;
	};
};
#endif

