
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Products_ProductCategory_ICE_
#define _Oz_Products_ProductCategory_ICE_

#ifndef INCLUDE_OZ_PRODUCTS_PRODUCTNODE
#define INCLUDE_OZ_PRODUCTS_PRODUCTNODE
	#include <Products/ProductNode.ice>
#endif

#ifndef INCLUDE_OZ_PRODUCTS_PRODUCT
#define INCLUDE_OZ_PRODUCTS_PRODUCT
	#include <Products/Product.ice>
#endif

module Oz
{
	module Products
	{
		class ProductCategory;
		
		interface ProductCategoryAdmin 
		{
			idempotent ProductCategory* 
			addCategory(
				ProductCategory category);	
			
			idempotent Product* 
			addProduct(
				Product producto);
			
			idempotent bool 
			delNode(
				string name);
			
			nonmutating ProductNodeMap 
			getNodes();
			
			nonmutating ProductNode* 
			getNode(
				string name);
		};

		class ProductCategory 
			extends 
				ProductNode 
			implements 
				ProductCategoryAdmin
		{
				ProductNodeMap nodes;
		};

		dictionary<Ice::Identity,ProductCategory*> ProductCategoryMap;
	};
};
#endif

