
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Products_ProductNode_H_
#define _Oz_Products_ProductNode_H_

//Oz includes

#ifndef INCLUDE_OZ_BASE_BASE
#define INCLUDE_OZ_BASE_BASE
	#include <Base/Base.ice>
#endif

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_FILES_FILESYSTEM
#define INCLUDE_OZ_FILES_FILESYSTEM
	#include <Files/FileSystem.ice>
#endif

module Oz
{
	module Products
	{
		class ProductNode;

		interface ProductNodeAdmin
		{
			idempotent bool 
			setName(
				string name);
			
			nonmutating string 
			getName();
			
			idempotent bool 
			setDescription(
				string description);
			
			nonmutating string 
			getDescription();		
			
			idempotent bool 
			setFileSystem(
				Oz::Files::FileSystem* fileSys);
			
			nonmutating Oz::Files::FileSystem* 
			getFileSystem();
			
			nonmutating Oz::Files::File* 
			getIcon();
			
			nonmutating Oz::Files::Directory* 
			getFiles();
			
			idempotent Oz::Files::Node* 
			addNode(
				string name,
				string path,
				string type);
	
			idempotent bool 
			setIcon(
				Oz::Files::File* icon);
			
			idempotent bool 
			setFiles(
				Oz::Files::Directory* ficheros);
			
			nonmutating string 
			getCodigo();
			
			idempotent bool 
			setCodigo(string codigo);
			
			nonmutating ProductNode* 
			getParent();
			
			idempotent bool 
			setParent(
				ProductNode* parent);
			
			idempotent bool 
			moveTo(
				ProductNode* parent);
				
			idempotent void
			publish(bool pusblished);
			
			nonmutating bool
			isPublished();
		};
		
		class ProductNode 
			extends 
				Oz::Base::OnRez 
			implements 
				ProductNodeAdmin
		{
				ProductNode* parent;
				string name;
				string description;
				Oz::Files::FileSystem* fileSys;
				Oz::Files::File* icon;
				string codigo;
				bool published;
				Oz::Files::Directory* ficheros;
		};
		
		dictionary<string,ProductNode* >ProductNodeMap;
	};
};
#endif

