
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Reports_XslFooFop_ICE_
#define _Oz_Reports_XslFooFop_ICE_

/**
 * Esta clase permite ejecutar tranformaciones XslFoo   en el servidor
 * utilizando apache fop
 */
 
#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_BASE_DATE
#define INCLUDE_OZ_BASE_DATE
	#include <Base/Date.ice>
#endif

module Oz
{
	module Reports
	{	
		interface XslFooFopClient
		{		
			idempotent void 
			renderXsl(
				string xmlData,
				string xslTemplate,
				string ouputFile,
				string driverName);

			nonmutating string 
			getStatus();
		};
		
		class XslFooFop implements XslFooFopClient
		{
			Ice::Identity id;
			Oz::Base::Date creationDate;
			string status;
		};
		
		dictionary<Ice::Identity,XslFooFop*> XslFooFopMap;
	};
};
#endif

