
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy ot it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Reports_XslFooService_ICE_
#define _Oz_Reports_XslFooService_ICE_

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

#ifndef INCLUDE_OZ_REPORTS_XSLFOOFOP
#define INCLUDE_OZ_REPORTS_XSLFOOFOP
	#include <Reports/XslFooFop.ice>
#endif

module Oz
{
	module Reports
	{
		interface XslFooServerAdmin
		{
			nonmutating Ice::Identity getId();
			nonmutating XslFooFop* getFopProcesor(Ice::Identity id);
			nonmutating XslFooFopMap getFopProcesors();
			
			idempotent bool deleteFopProcesor(Ice::Identity id);
		};
		
		interface XslFooServerClient
		{
			idempotent XslFooFop* createFopProcesor();
		};
		
		
		class XslFooServer 
			implements 
				XslFooServerClient,
				XslFooServerAdmin
		{
			Ice::Identity id;
			XslFooFopMap procesors;
		};
	};
};
#endif

