
/***************************************************************************/
/*Copyright (C)  On-Rez                                                   **/
/*www.on-rez.com                                                          **/
/*                                                                        **/
/*This code is licensed to you under the terms of GPL license             **/
/*a copy of it is available with the sources in the file LICENSE.         **/
/*you can view online at http://www.gnu.org/licenses/gpl.txt              **/
/***************************************************************************/

#ifndef _Oz_Shops_LineItem_ICE_
#define _Oz_Shops_LineItem_ICE_

//Ice includes

#ifndef INCLUDE_ICE_IDENTITY
#define INCLUDE_ICE_IDENTITY
	#include <Ice/Identity.ice>
#endif

//Oz includes

#ifndef INCLUDE_OZ_BASE_ONREZ
#define INCLUDE_OZ_BASE_ONREZ
	#include <Base/OnRez.ice>
#endif

#ifndef INCLUDE_OZ_PRODUCTS_PRODUCT
#define INCLUDE_OZ_PRODUCTS_PRODUCT
	#include <Products/Product.ice>
#endif

module Oz
{
	module Shops
	{	
		class LineItem;
		interface LineItemAdmin
		{
			idempotent int 
			addUnits(
				int units);
			
			idempotent int 
			delUnits(
				int units);
			
			idempotent bool 
			setProduct(
				Oz::Products::Product* producto);
			
			idempotent bool 
			setPrice(
				double price);
		};
		
		interface LineItemClient
		{			
			nonmutating int 
			getUnits();
			
			nonmutating Oz::Products::Product* 
			getProduct();
			
			nonmutating double 
			getPrice();
			
			nonmutating double 
			getTotal();
			
			nonmutating string 
			getName();
			
			nonmutating string 
			getDescription();
		};
		
		class LineItem 
			extends 
				Oz::Base::OnRez 
			implements 
				LineItemAdmin,
				LineItemClient
		{
			Oz::Products::Product* product;
			Ice::Identity productId;
			string name;
			string description;
			int units;
			double price;
		};
		
		dictionary<Ice::Identity,LineItem*> LineItemMap;
		["java:type:java.util.TreeMap"]dictionary<int,LineItem*> LineItemNumberMap;
	};
};
#endif

